
  unit Unit1;

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
 StdCtrls, ExtCtrls;

type
 TForm1 = class(TForm)

    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
   procedure Timer1Timer(Sender: TObject);
   procedure FormCreate(Sender: TObject);
   procedure FormClose(Sender: TObject; var Action: TCloseAction);

 private
   procedure AskScreen(TerminalID,ScrName:String);
   procedure ReceiveScreen(TerminalID,ScrName:String);
   procedure DoScreen(ScrName:String);
 public
   { Public declarations }
 end;

Const

GetText_flag_Protected = -1;
GetText_flag_AutoExit = -2;
GetText_flag_Password = -4;
GetText_flag_Number = -8   ;
GetText_flag_ExitEnter = -16;
GetText_flag_ExitAlways = -32;
GetText_flag_Barcode = -64    ;
GetText_flag_NotUnderline = -128 ;
GetText_flag_Link = -256          ;
GetText_flag_NewText = -512        ;
GetText_flag_NumberRightAligned = -1024 ;
GetText_flag_DontShowZero = -2048        ;
GetText_flag_ForceFunctionKeys = -4096    ;


scr_flag_execute = 1;
scr_flag_changed = 2;
scr_flag_update_pc_if_possible = 4;
scr_flag_update_pc_now = 8;
scr_flag_update_pc_later = 16;
scr_flag_auto_destroy = 32;
scr_flag_ask_pc_answer = 64;
scr_flag_restore_fields_after_send = 256;
scr_flag_dont_stop = 512;
scr_flag_dont_cls = 1024;



data_type_send_screen_zipped = 1 ;
data_type_ask_screen = 2          ;
data_type_reset = 3                ;
data_type_send_screen_unzipped = 4  ;
data_type_send_raw_data = 7          ;

var
Form1: TForm1;
Description:String;
barcode:String;

implementation

function InitializeComm (ComPort:Integer; BaudRate:Integer):Integer ; stdcall; external 'riocom.dll';
function TerminateComm (ComPort:Integer):Integer ; stdcall; external 'riocom.dll';
function T_InitScreen (TerminalID:String;ScreenName:String; Screenflags:Integer;Screencursor:Integer;Screenvalidate:Integer):Integer ; stdcall; external 'riocom.dll';
function T_PrintString (txt:String):Integer ; stdcall; external 'riocom.dll';
function T_HardReset:Integer ; stdcall; external 'riocom.dll';
function T_EmptyScreenBuffers:Integer ; stdcall; external 'riocom.dll';
function T_Cls:Integer ; stdcall; external 'riocom.dll';
function T_Read:Integer ; stdcall; external 'riocom.dll';
function T_EndRepeat:Integer ; stdcall; external 'riocom.dll';
function T_ShowDisplay:Integer ; stdcall; external 'riocom.dll';
function T_SendScreen:Integer ; stdcall; external 'riocom.dll';
function T_WaitChar:Byte ; stdcall; external 'riocom.dll';
function T_CheckIfReceiveData(TerminalID:String;ScreenName:String;var DataType:Byte;var Rawdatasize:Integer;Rawdata:String):Integer ; stdcall; external 'riocom.dll';
function T_RefreshScreen (TerminalID:String;ScreenName:String):Integer ; stdcall; external 'riocom.dll';
function T_GotoScreen (ScreenName:String):Integer ; stdcall; external 'riocom.dll';
function T_SaveScreens (FileName:String):Integer ; stdcall; external 'riocom.dll';
function T_LoadScreens (FileName:String):Integer ; stdcall; external 'riocom.dll';
function T_SaveComunicationStatus (FileName:String):Integer ; stdcall; external 'riocom.dll';
function T_LoadComunicationStatus (FileName:String):Integer ; stdcall; external 'riocom.dll';
function T_SetSeconds (Seconds:Integer):Integer ; stdcall; external 'riocom.dll';
function T_Delay (miliSeconds:Integer):Integer ; stdcall; external 'riocom.dll';
function T_ActivateListIndex (ListName:String):Integer ; stdcall; external 'riocom.dll';
function T_PrintInverse (txt:String):Integer ; stdcall; external 'riocom.dll';
function T_PrintLarge (txt:String):Integer ; stdcall; external 'riocom.dll';
function T_Say (txt:String):Integer ; stdcall; external 'riocom.dll';
function T_NoSay (size:Integer):Integer ; stdcall; external 'riocom.dll';
function T_NewLine:Integer ; stdcall; external 'riocom.dll';
function T_GetTextFromList(var Number:Integer;size:Integer;ScreenName:String):Integer ; stdcall; external 'riocom.dll';
function T_GetText(txt:String;size,flags:Integer):Integer ; stdcall; external 'riocom.dll';
function T_Beep(duration,periodo:Integer):Integer ; stdcall; external 'riocom.dll';
function T_SendScreenToPc(ScreenName:String;scr_flag:integer):Integer ; stdcall; external 'riocom.dll';
function T_OnEscapeGotoScreen (ScreenName:String):Integer ; stdcall; external 'riocom.dll';
function T_OnF4GotoScreen (ScreenName:String):Integer ; stdcall; external 'riocom.dll';
function T_SetFunctionKeys (Keys:String):Integer ; stdcall; external 'riocom.dll';
function T_GetLink(ScreenName:String;value:integer;FastKey:Byte):Integer ; stdcall; external 'riocom.dll';
function T_GetTextTemplate(txt,template:String;flags:integer):Integer ; stdcall; external 'riocom.dll';
function T_GetOption(var Position:Integer;List:String;LenList,Max:Integer):Integer ; stdcall; external 'riocom.dll';
function T_SetGetTextFromListFlags (flags:Integer):Integer ; stdcall; external 'riocom.dll';
function T_StartRepeat (var times:Integer):Integer ; stdcall; external 'riocom.dll';
function T_GetNumerical (var Number:Integer;size,flags:Integer):Integer ; stdcall; external 'riocom.dll';
function T_GetRepeat(Times:Byte):Integer ; stdcall; external 'riocom.dll';
function T_SetDisplay(DisplayNumber:Byte):Integer ; stdcall; external 'riocom.dll';
function T_SendScreenToNull(ScreenName:String;scr_flag:integer):Integer ; stdcall; external 'riocom.dll';
function T_PutTextOnList(txt:String;value,fastkey:Integer):Integer ; stdcall; external 'riocom.dll';
function T_CreateListIndex(ListName:String;size:Integer):Integer ; stdcall; external 'riocom.dll';



{$R *.DFM}

procedure TForm1.ReceiveScreen(TerminalID,ScrName:String);
begin
  T_RefreshScreen(TerminalId, ScrName);
  DoScreen(ScrName);
end;

procedure TForm1.AskScreen(TerminalID,ScrName:String);
begin
  if Pchar(ScrName)='START'
  then
    begin
    barcode:=Chr(0)+StringOfChar(' ',10);
    Description:=Chr(0)+StringOfChar(' ',10);
    ScrName:='LE REF';
    end;

if Pchar(ScrName)='LE REF'
 then
  begin
      Description:=Chr(0)+StringOfChar(' ',10);
      if copy(barcode,1,8)='49020300' then
      Description:='Disquetes ';
      if copy(barcode,1,8)='RR545961' then
      Description:='CTT       ';
      if copy(barcode,1,8)='75362297' then
      Description:='Caixa CD  ';
      T_InitScreen (TerminalId, ScrName, scr_flag_execute + scr_flag_auto_destroy, 0, 0);
      DoScreen(ScrName);
      T_SendScreen;

      Label1.Caption:=barcode;
      Label2.Caption:=Description;

  end;
end;

procedure TForm1.DoScreen(ScrName:String);

begin

if Pchar(ScrName)='LE REF'
 then
  begin

   T_Say('>');
   T_GetText(barcode,10,GetText_flag_Barcode + GetText_flag_ExitEnter);
   T_NewLine;
   T_PrintString('>');
   T_PrintString(Description);

   T_Beep(50,50);
   T_Read;
   T_SendScreenToPc('LE REF', scr_flag_update_pc_now + scr_flag_auto_destroy );
   T_GotoScreen('LE REF');
  end;
end;





procedure TForm1.Timer1Timer(Sender: TObject);
var terminalid,screenName,RawData:String;
DataType:Byte;
RawDataSize:INteger;
begin
TerminalId:=StringOfChar(' ',9);
ScreenName:=StringOfChar(' ',50);
RawData:=StringOfChar(' ',2000);

while  T_CheckIfReceiveData(TerminalId, ScreenName,  DataType, RawDataSize, RawData)<>0 do
begin
case Datatype of
  data_type_send_screen_zipped:ReceiveScreen(TerminalId, ScreenName);
  data_type_send_screen_unzipped:ReceiveScreen(TerminalId, ScreenName);
  data_type_ask_screen:AskScreen(TerminalId, ScreenName);
 end;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
InitializeComm( 3, 19200);

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
TerminateComm(3);
end;

end.

